module Mailchimpv3
  class List
    attr_accessor :id, :contact, :name, :permission_reminder,
                  :campaign_defaults, :email_type_option, :master, :member_count, :saved

    def initialize(master=nil,id="", name="", contact={}, permission_reminder="",
                  campaign_defaults={},member_count=0, email_type_option=true)
      @master = master
      @id = id
      @name = name
      @contact = contact
      @permission_reminder = permission_reminder
      @campaign_defaults = campaign_defaults
      @email_type_option = email_type_option
      @member_count = member_count
      @saved = false
    end

    def find(id, params={fields: 'lists.id, lists.name, lists.contact,
                        lists.permission_reminder,lists.campaign_defaults,
                        lists.email_type_option,lists.stats.member_count'})

      response = @master.get("/lists/#{id}", params)
      @id = response["id"]
      @name = response["name"]
      @contact = response["contact"]
      @permission_reminder = response["permission_reminder"]
      @campaign_defaults = response["campaign_defaults"],
      @member_count = response["member_count"].to_i
      @email_type_option = ["email_type_option"]
      @saved = true
      self
    end

    def save()
      response = @master.post("/lists", {
          :name => @name,
          :contact => @contact,
          :permission_reminder => @permission_reminder,
          :campaign_defaults => @campaign_defaults,
          :email_type_option => @email_type_option
        })
      @saved = true
      @id = response["id"]
      self
    end

    def addmember(email_address, status)
      response = @master.post("/lists/#{@id}/members", {
          :email_address => email_address,
          :status => status
        })
      @member_count = @member_count + 1
      response
    end
  end
end
